<?php
/* 
 * En vez de usar una clase PROCESS central extensa, cada formObject procesa sus
 * propios valores a travez de una funcion interna y devuelve la respuesta a la
 * clase form que toma acción.
 *
 * El sistema formHandler funciona con tres estructuras subdivididas en clases:
form :  Es la clase que administra las demas clases de formularios.
formObject: Es la clase base de cada formObject

textfield
formfield
button
hidden          =  Cada clase en particular que generan objetos
file
radio
selectbox
checkbox
textarea
 */

class form {
    public $method;
    protected $error = array();
    protected $formPublicProperty = array();
    
    protected $itemsAsHtml = array();
    public $formEncType;
    public $field;
    public $action;
    public function __construct(){
      
       // $this->formEncType = "text/plain";   
    }
    // Guarda los errores en un array para posteriores operacoines.
    protected function generateFormError($alias,$description){
        $this->error[$alias][] = $description;
        $this->errno[$alias][] = $description;
    }

    // SACo errores
    public function retrieveFormError(){
        
    }
    
    
    // Devuelve los valores ingresados como html.
    public function returnRealHtml(){ 
        foreach($this->field as $item){
            switch($item->type){
                case "form":
                    $this->itemsAsHtml[$item->name] = $item->returnRealHtml($this->action,$this->formEncType);
                break;
                case "textfield":
                    $this->itemsAsHtml[$item->name]= $item->returnRealHtml();
                break;
                case "textarea":
                    $this->itemsAsHtml[$item->name] = $item->returnRealHtml();
                break;
                case "radio":
                    $this->itemsAsHtml[$item->name] = $item->returnRealHtml();
                break;
                case "checkbox":
                   $this->itemsAsHtml[$item->name] = $item->returnRealHtml();
                break;
                case "selectbox":
                    $this->itemsAsHtml[$item->name] = $item->returnRealHtml();
                break;
                case "file":
                     $this->itemsAsHtml[$item->name] = $item->returnRealHtml();
                break;
                case "button":
                    $this->itemsAsHtml[$item->name] = $item->returnRealHtml();
                break;
                case "submit":
                    $this->itemsAsHtml[$item->name] = $item->returnRealHtml();
                break;
                case "hidden":
                    $this->itemsAsHtml[$item->name] = $item->returnRealHtml();
                break;
            }
        }
        return $this->itemsAsHtml;
    }
    private $itmList;
    private $rfasHeader = -1; 
    // Devuelve los valores ingresados como un array.
    public function returnFormAsObjects($field){
        if(is_null($field)){
            $this->rfasHeader++;
            if(isset($this->field[$this->itmList[$this->rfasHeader]])){
                return $this->field[$this->itmList[$this->rfasHeader]];
            }else{
                $this->rfasHeader = -1;
                return false;
            }
            
        }else{
            return $this->field[$field];
        }
    }
    //Is submited form property
    public function is_submited($formObject){
        
    }

    // FUNCIONES PARA GENERAR FORM OBJECTS
    public function newForm($alias,$action,$method,$encType){
        $this->method = $method;
        $this->itmList[] = $alias;
        $this->action = $action;
        if($encType){
            $this->formEncType = "enctype='text/plain'";
         }else{
           $this->formEncType = "enctype='".$encType."'";
         }
         //$this->formEncType = "ASDEASD";
         
         $this->field[$alias]= new formfield($alias, "post");
         return $this->field[$alias];
    }
    //public function formChangeAction($action)
    // Genera un nuevo file chooser
    public function newFile($alias,$value){
        $this->itmList[] = $alias;
        $this->formEncType = "multipart/form-data";
        $this->field[$alias] = new file($alias, $value);
     }
     //Create a hidden field
     public function newHidden($alias,$value){
        $this->itmList[] = $alias;
        $this->field[$alias] = new hidden($alias,$value);
        return $this->field[$alias];
     }
     // Genera un nuevo Radio button
     public function newRadio($alias,$labels,$values,$selected){
        $this->itmList[] = $alias;
        $this->field[$alias] = new radio($alias,$labels,$values,$selected);
        return $this->field[$alias];
     }
     // Genera un nuevo select box
     public function newSelectBox($alias,$labels,$values,$selected){
       $this->itmList[] = $alias;
        
        $this->field[$alias] = new selectbox($alias, $labels, $values, $selected);
        return $this->field[$alias];
     }
    //Genera un nuevo checkBox
    public function newCheckBox($alias,$label,$value,$checked){
        $this->itmList[] = $alias;
        $this->field[$alias] = new checkbox($alias, $label, $value, $checked);
        return $this->field[$alias];
    }
    // Genera un nuevo TextField
    public function newTextField($alias,$value,$charWidth,$minlenght,$maxlenght){
        $this->itmList[] = $alias;
        $this->field[$alias] = new textfield($alias, $value, $charWidth, $minlenght, $maxlenght);
        return $this->field[$alias];

    }
    // Genera un nuevo Textarea
    public function newTextarea($alias,$value,$columns,$maxlenght,$charWidth,$charHeight){
        $this->itmList[] = $alias;
        $this->field[$alias] = new textarea($alias, $value, $charWidth,$columns, $maxlenght,$asf);
        return $this->field[$alias];

   }
    // Genera un nuevo boton
    public function newButton($alias,$type,$value,$active){
        $this->itmList[] = $alias; 
        $this->field[$alias] = new button($alias, $value, $type);
        return $this->field[$alias];
     }
    // Procesa los datos ingresados por el usuario, los analiza y devuelve la información libre de errores.
    public function formProcess($itp){
        foreach($this->field as $item){
            if(in_array($item->name,$itp)){
                if(!is_null($_POST[$item->name])){
                    $item->value = $_POST[$item->name];
                }
                if(($item->type == "textfield") or ($item->type == "textarea")){
                    $push = $item->process($_POST);
                    if($push != null){
                        foreach($push as $newError){
                            //@echo($newError[0]
                            $this->generateFormError($newError[0],$newError[2]);
                        }
                    }
                    // Decide que valores son validos para un campo de email.
                }
                if($item->type == "checkbox"){
                    $item->process($realVal);
                }


                if($item->type == "selectbox"){
                     $item->process($realVal);
                }
            }
        }
       if(count($this->error)>0){
       
        return $this->error;
       }else{
        return null;
       }
    }
}


// Clase base de la cual se extienden todos los otros objetos
class formObject {
    public $type;
    public $name;
    public $value;
    public $id;
    public $notEmpty;
    public $fieldCheck;
    public $maximumLength;
    public $minimumLenght;
    public $charWidth;
    public $charHeight;
    public $numLines;
    public $disabled;
    public $readonly;
    public $error;
    //Devuelve el tipo de objeto FormObject.
    protected function getFOType(){
        return $this->type;
    }

}
// TENGO QUE EXPLICAR COMO FUNCIONA ESTE MODELO
class textfield extends formObject{
    private $alias;
    public $isEmailDir;
    function __construct($alias,$value,$charWidth,$minlenght,$maxlenght){
        $this->name = $alias;
        $this->type = "textfield";
        $this->value = $value;
        $this->id = $alias;
        $this->charWidth = $charWidth; 
        $this->minlenght = $minlenght;
        $this->maxlength = $maxlenght; 
        if(is_int($charWidth)){
            if($charWidth >=0 ){
                $property["charWidth"] = $charWidth;
            }else{
                // Valor invalido, setear alert
            }
        }
        if(is_int($minlenght)){
            if($minlenght >= 0){
                $property["minlenght"] = $minlenght;
            }else{
                // Valor invalido, setear alert
            }
        }
        if(is_int($maxlenght)){
            if($maxlenght >= 0){
                $property["maxlenght"] = $maxlenght;
            }else{
                // Valor invalido, setear alert
            }
        }
    }
    public function process($realVal){
        // CORRECT EMAIL DIRECTION COMPROBATION CHECKLIST START
        if($this->isEmailDir){
            $this->itmList[$this->name]["notEmpty"] = true;
            $ssc = substr_count($realVal[$this->name],"@");
            if($ssc>1){
                $this->error[] = Array($this->name, "textfield", "There can't be more than one @");
            }
            if($ssc<1){
                $this->error[] = Array($this->name, "textfield", "Not @ found");
            }
            if(strlen(substr($realVal[$this->name],0,strpos($realVal[$this->name],"@")))<1){
                $this->error[] = Array($this->name, "textfield", "Invalid mail direction");
            }
            if(strpos($realVal[$this->name]," ")>0){
                $this->error[] = Array($this->name, "textfield", "Space invalid");
            }
            if(!strpos($realVal[$this->name],".")>0){
                $this->error[] = Array($this->name, "textfield", "Dot invalid");
            }
        }
        // COMPROBATION END
        //STANDARD TEXTFIELD COMPROBATIOn CHECKLIST
        if(strlen($realVal[$this->name])  < $this->minlenght){
            $this->error[] = Array($this->name, "textfield", "Min textfield lenght reached");
        }
        if(strlen($realVal[$this->name])  > $this->maxlength){
            $this->error[] = Array($this->name, "textfield", "Max textfield lenght reached");
        }
        //COMPROBATION END
        return $this->error;
    }


    public function returnRealHtml(){ 
        if(isset($this->value)){
            $value = "value='".$this->value."'";
        }
        if(isset($this->class)){
            $class = "class='".$this->class."'";
        }
        if(isset($this->charWidth)){
            $charWidth = "size='".$this->charWidth."'";
        }
        if(isset($this->maxlength)){
            $maxLenght = "maxlenght='".$this->maxlength."'";
        }
        return "<input type ='textfield' name='".$this->name."' id='".$this->name."' ".$value." ".$class." ".$maxLenght." ".$charWidth." > ";
    }
}

class formfield extends formObject {
    public $encType;
    public function __construct($alias,$method){
        $this->type = "form";
        $this->method = $method;
        $this->name = $alias;
    }
    public function returnRealHtml($action,$fet){
        if(isset($fet)){
            $fet = "enctype='".$fet."' ";
        }
        $form["begin"] = "<form action='".$action."' method='".$this->method."' ".$fet."> ";
        $form["end"] = "</form>";
        $form["type"] = "form";
        return $form;
    }
    public function is_submited(){

    }
}
class button extends formObject {
    public $label;
    public function __construct($alias,$label,$type){
        $this->type = $type;
        $this->name = $alias;
        $this->value = $label;
    }
    public function returnRealHtml(){
         return " <input type='".$this->type."' value='".$this->value."' name='".$this->name."'> ";
    }
}
class hidden extends formObject {
    public $label;
    public function __construct($alias,$value){
        $this->type = "hidden";
        $this->name = $alias;
        $this->value = $value;
    }
    public function returnRealHtml(){
        return "<input type='".$this->type."' value='".$this->value."' name='".$this->name."'> ";
    }
}
class file extends formObject {
    public function __construct($alias,$value){
        $this->type = "file";
        $this->name = $alias;
        $this->value = $value;
    }
    public function returnRealHtml(){
        return "<input type='file' name='".$this->name."' id='".$this->name."' /> ";
    }
}
class radio extends formObject {
    public function __construct($alias,$label,$values,$selected){
        $this->type = "radio";
        $this->label = $label;
        $this->name = $alias;
        $this->value = $values;
    }
    public function returnRealHtml(){
        $i = 0;
        $radioTemp;
        foreach($this->label as $v){
            $checked = "";
            if($v === $this->checked){
                $checked = "checked='checked'";
            }
            $i++;
            //RETORNA LOS ITEMS POR EL NOMBRE DEL GRUPO: $item["name"]  y el nombre de la opción
            $radioTemp[$v] = "<input type='radio' name='".$this->name."' value='".$this->value[$i]."' ".$checked." > ";
        }
        return $radioTemp;
    }
}
class selectbox extends formObject {
    public $selected;
    public $contains;
    public function __construct($alias,$lbl,$values,$selected){
       $this->type = "selectbox";
        $this->label = $lbl;
        $this->name = $alias;
        $this->value = $values;
        $this->contains = $values;
        $this->selected = $selected;
        

    }
    public function returnRealHtml(){
        //Procesa los valores para devolverlos como opciones.
        $i = 0;
        foreach($this->label as $v){
            $selected = "";
            if($v === $this->selected){
                $selected = "selected='".$v."'";
            }
            if(is_array($this->value)){
                $val = "value='".$this->value[$i]."'";
            }
            $i++;
            $selectField .= "<option ".$selected." ".$val." >".$v."</option> ";
         }
         //--------------------------------------------------
         return "<select name='".$this->name."' id='".$this->id."' >".$selectField."</select> ";
    }
    public function process($realVal){
        if(isset($realVal[$this->name])){
            $this->selected = $realVal[$this->name];
            //--------------------
           if(!in_array($realVal[$this->name],$this->contains)){
                echo("not in array");
            }
        }

    }
}
class checkbox extends formObject {
    public $checked;
    public function __construct($alias,$label,$values,$selected){
        $this->type = "checkbox";
        $this->label = $label;
        $this->name = $alias;
        $this->value = $values;
        if($selected){
            $this->checked = "checked='checked'";
        }
    }
    public function process($realVal){
        if(isset($realVal[$this->name])){
            $this->checked = "checked='checked'";
        }else{
            $this->checked = "";
        }
    }
    public function returnRealHtml(){
        return "<input type='checkbox' name='".$this->name."' value='".$this->value."' ".$this->checked." > ";
    }
}
class textarea extends formObject {
    public $isEmailDir;
    public $columns;
    public $rows;
    public function __construct($alias,$value,$columns,$rows,$maxlenght,$charWidth){
        $this->type = "textarea";
        $this->value = $value;
        $this->name = $alias;
        $this->minimumLenght = $minlenght;
        $this->maximumLength = $maxlenght;
        $this->columns = $columns;
        $this->charWidth = $charWidth;
        $this->rows = $rows;
    }
    public function process($realVal){
        // CORRECT EMAIL DIRECTION COMPROBATION CHECKLIST START
        if($this->isEmailDir){
            $this->itmList[$this->name]["notEmpty"] = true;
            $ssc = substr_count($realVal[$this->name],"@");
            if($ssc>1){
                $this->error[] = Array($this->name, "textarea", "There can't be more than one @");
            }
            if($ssc<1){
                $this->error[] = Array($this->name, "textarea", "Not @ found");
            }
            if(strlen(substr($realVal[$this->name],0,strpos($realVal[$this->name],"@")))<1){
                $this->error[] = Array($this->name, "textarea", "Invalid mail direction");
            }
            if(strpos($realVal[$this->name]," ")>0){
                $this->error[] = Array($this->name, "textarea", "Space invalid");
            }
            if(!strpos($realVal[$this->name],".")>0){
                $this->error[] = Array($this->name, "textarea", "Dot invalid");
            }
        }
        // COMPROBATION END
        //STANDARD TEXTFIELD COMPROBATIOn CHECKLIST
        if(strlen($realVal[$this->name])  < $this->minlenght){
            $this->error[] = Array($this->name, "textarea", "Min textfield lenght reached");
        }
        //echo("<br>".strlen($realVal[$this->name])." > ".$this->maxLength."<br>");
        if(strlen($realVal[$this->name])  > $this->maximumLength){
            $this->error[] = Array($this->name, "textarea", "Max textfield lenght reached");
        }
        //COMPROBATION END
        return $this->error;


    }
    public function returnRealHtml(){
        if(isset($this->class)){
            $class = "class='".$this->class."'";
        }
        if(isset($this->columns)){
            $charWidth = "cols='".$this->columns."'";
        }
        if(isset($this->rows)){
            $charHeight = "rows='".$this->rows."'";
        }
        if(isset($this->disabled)){
            if($this->disabled){
                $disabled = "disabled='disabled'";
            }
        }
        if(isset($this->readonly)){
            if($this["readonly"]){
                $readonly = "readonly='readonly'";
            }
        }
        if(isset($this->maxlength)){
            $maxLenght = "maxlenght='".$this->maxlenght."'";
       }
       return  "<textarea name='".$this->name."' id='".$this->name."' ".$class." ".$maxLenght." ".$charWidth." ".$charHeight." ".$disabled." ".$readonly." >".$this->value."</textarea> ";
    }
}

?>
