<?php
//CLASE PROTOTIPO PARA EL MANEJO UNIFORME DE BASES DE DATOS
class database {
    // Database Type
    private $dbType;
    // Connect object
    private $co;
    //Connect variable
    public $conex;
    //Database alias
    public $connectionAlias;
    public function __construct($dbAlias){
        global $system;
        global $database;
        
        // Checkea si el alias dado existe en el archivo de configuración
        if(!is_array($database[$dbAlias])){
            panic2("DataHandler",1150,"Database alias given is incorrect or inexistent",true);
        }
        
        $this->dbType = $database[$dbAlias]["databaseType"];
        
        //Arranca la base de datos mysql si este es el tipo de base de datos.
        if($this->dbType === "mysql"){
            $this->conex = new mysqlManager();
            $this->co = $database[$dbAlias];
        }
        $this->connectionAlias = $dbAlias;
    }
    public function connect(){
            return $this->conex->connect($this->co);
    }
    public function query($query){
            return $this->conex->query($query,$this->connectionAlias);
    }
    public function search($alias,$lookField,$searchVals,$operand,$needleVals,$orderBy,$selectRange,$extra){
        return $this->conex->search($alias,$lookField,$searchVals,$operand,$needleVals,$orderBy,$selectRange,$extra,$this->connectionAlias);
    }
    public function db_fetch_search($searchResourceLink){
        return $this->conex->db_fetch_search($searchResourceLink);
    }
    public function selectDatabase($database){
            return $this->conex->selectDatabase($database,$this->connectionAlias);
    }
    public function retrieveDataById($dbObject,$fields,$id,$orderBy,$selectRange,$method){
            return $this->conex->retrieveDataById($dbObject, $fields, $id, $orderBy, $selectRange, $method,$this->connectionAlias);
    }
    public function dropTable($alias){
            return $this->conex->dropTable($alias,$this->connectionAlias);
    }
    public function createQuickRegister($dbObject, $insData, $cData){
            return $this->conex->createQuickRegister($dbObject, $insData, $cData,$this->connectionAlias);
    }
    public function editQuickRegister($dbObject, $insData, $cData, $id){
            return $this->conex->editQuickRegister($dbObject, $insData, $cData, $id,$this->connectionAlias);
    }
    public function deleteQuickRegister($dbObject, $id){
            return $this->conex->deleteQuickRegister($dbObject, $id,$this->connectionAlias);
    }
    public function retrieveColumns($table){
            return $this->conex->retrieveColumns($table,$this->connectionAlias);
    }
    public function retrieveExtraTables(){
            return $this->conex->retrieveExtraTables($this->connectionAlias);
    }
    public function executeBackup($database, $ins_prop, $dir){
            return $this->conex->executeBackup($database, $ins_prop, $dir);
    }
}
?>
