<?php
/**
 *
 * Esta clase se encarga del manejo de operaciones con bases de datos
 * MySql.
 *
 * @author Nicanor Gioffré
 */
class mysqlManager {
    public function _construct(){
        
    }
    
    private $activeConnections = array(); //Variable que contiene la lista de todas las conecciones activas
    // Por defecto si un query falla se ejecuta la función Panic();
    public $queryCreatesPanic = true;
    //Intenta una conexión con el servidor MYSQL.
    public function connect($connectObj){
       global $activeConnections;
       global $dbData;
       global $system;
        // El sistema checkea si tiene las condiciones iniciales necesarias:
        if(!isset($connectObj["alias"])){
            panic2("DataHandler",1001,"Database alias given is incorrect or inexistent",true);
        }
        
        if(!in_array(strtolower($connectObj["databaseType"]),$system->availableDBS)){
           panic2("DataHandler",1002,"Database type requested is currently not supported",true);
        }
        if(!in_array(strtolower($connectObj["databaseEngine"]),$system->availableDBE)){
           panic2("DataHandler",1003,"Database engine type requested is currently not supported",true);
        }
        //if

        //echo($system->availableDBS[0]);
        //Agregar: Función del sistema de seguridad para checkear si los datos son validos
        //AGREGAR OPCIÓN PARA PERSISTENT CONNECTION
        $link = mysql_connect($connectObj["url"],$connectObj["username"],$connectObj["password"]);
        //Determina si la conexión fue exitosa
        if($link){
            // Determina si hay una base de datos ingresada para seleccionar
            if($connectObj["database"] != ""){
                if(!mysql_select_db($connectObj["database"],$link)){
                   //Si la base de datos no se puede seleccionar se genera un error (Panic)
                   panic2("DataHandler",1000,mysql_error(),true);
                }else{
                    if(isset($connectObj["alias"])){
                        // Si existe un db alias se le indica al kernell
                        if(getDBRByAlias($connectObj["alias"])){
                           // CHECKEAR SI LA CONEXION YA EXISTE 
                        }
                        newDBRL($connectObj["alias"],$link);
                    }
                }
            }
            $activeConnections[] = array($connectObj["url"],$connectObj["username"],$connectObj["password"],$link);
            $this->retrieveExtraTables($connectObj["alias"]);
           
            //Devuelve el Connecqwtion resource
            return $link;
        }else{
            //Si php no se puede conectar con la base de datos genera un error (Panic)
            panic2("DataHandler",1000,mysql_error(),true);
        }
    }
    // Función para seleccionar una base de datos dentro del servidor
    public function selectDatabase($database,$link){
        if(@mysql_select_db($database,$link)){
            return true;
        }else{
            panic("dataHandler/sql",mysql_error());
        }
    }
    //Realiza una consulta a la base de datos y devuelve el resultado.
    public function query($query,$link){
        //SISTEMA DE SEGURIDAD --- QUERYES
        //echo($query."<br>");
        $mysqlQuery = @mysql_query($query,getDBRByAlias($link));
        if($mysqlQuery){
            return $mysqlQuery;
        }else{
            /* Si la consulta que se realiza no es escencial para el correcto
             * desarrollo y/o funcionamiento del sistema y puede ser obviada en
             * caso de que falle, se debe establecer la propiedad "queryCreatesPanic"
             * como false antes de ejecutar la consulta. De este modo se
             * evitara que el sistema detenga su ejecución.
             */
            if($this->queryCreatesPanic){
                panic("dataHandler/sql",mysql_error());
            }
        }
        
    }
    //Recoje datos de la base de datos y los devuelve como un array asociativo
    public $defaultSRD = "DESC";
    public function retrieveDataById($dbObject,$fields,$id,$orderBy,$selectRange,$method,$resource){
       global $dbData;
       
       $i=0;
       if($operatingFields === "*" or !isset($operatingFields) or is_null($operatingFields)){
        $operatingFields = $this->retrieveColumns($alias,$resource);
       }
        /* Si $operatingFields es un array, entonces le digo al query que quiero buscar
         * multiples columnas. (Las especificadas)
         */
       if(is_array($operatingFields)){
        foreach($operatingFields as $lfd){
            if($i ===0){
                $look4column = $lfd;
            }else{
                $look4column .= ",".$lfd;
            }
            $i++;
        }
       }
        // Si $operatingFields es un string busco solo el campo pedido
        if(is_string($operatingFields)){
            $look4column = $operatingFields;
        }
        //Si $operatingFields es null, busco todos los campos posibles.
        if(is_null($operatingFields)){
            $look4column = "*";
        }
        
        //Si esta establecido el parametro ID hay una clausula WHERE
        if(isset($id)){
            /* Si es un array , el usuario especifica los parametros de selecciòn. De otro modo si el usuario ingreso un
             * string o un integer como valor de id, se selecciona el parametro DEFAULT establecido en la tabla que contiene
             * la informaciòn de las bases de datos.
             */
            if(is_array($id)){
                $condition = "WHERE ".$id;
            }else{
                $condition = " WHERE ".$dbData[$dbObject]["uid"]."='".$id."'";
            }
        }
        
        // SETEO UN RANGO DE SELECCIÒN Y ORDEN DE DISPLAY PARA LOS RESULTADOS
        if(isset($orderBy)){
            //Para recordar: CHeckear si el valor ORDERBY es valido.
            $orderBy = "ORDER BY ".$orderBy;
        }
        // SETEO DE RANGO DE DATOS
        /* Si $selectRange es un array, entonces contiene dos valores entre los que se limitara la busqueda.
         * también puede contener como valor [0] un valor booleano indicando si el limite de busqueda es descendente (true)
         * o ascendente (false). En caso de que no este especificado, el sistema usa el default seteado en la variable
         * publica $this->defaultSRD. Si $selectRange no es un array busca los ùltimos o primeros (X) valores (Dependiendo
         * de la variable $this->defaultSRD)
         */
        if(is_null($selectRange)){
            $selectRange = "";
        }else{
            if(is_array($selectRange)){
                if(!isset($orderBy)){
                    $setOrderBy = "ORDER BY ".$dbData[$dbObject]["uid"];
                }
                if(is_bool($selectRange[0])){
                    if($selectRange[0]){
                        $limitDir = "DESC";
                    }else{
                        $limitDir = "ASC";
                    }
                    $selectRL = $selectRange[1];
                    $selectRR = $selectRange[2];
             }else{
                    $limitDir = $this->defaultSRD;
                    $selectRL = $selectRange[0];
                    $selectRR = $selectRange[1];
                }
           
                $rangeLimit = $setOrderBy." ".$limitDir." LIMIT ".$selectRL.",".$selectRR." ";
            }else{
            
                $rangeLimit = $setOrderBy." ".$limitDir." LIMIT ".$selectRange." ";
            }
        }

        //echo("SELECT ".$rFields." FROM ".$dbData[$dbObject]["tablename"]." ".$orderBy." ".$condition." ".$rangeLimit);
        //QUERY
//        echo("SELECT ".$rFields." FROM ".$dbData[$dbObject]["tablename"]." ".$orderBy." ".$condition." ".$rangeLimit);
        $rData = $this->query("SELECT ".$rFields." FROM ".$dbData[$dbObject]["tablename"]." ".$orderBy." ".$condition." ".$rangeLimit,$resource);;
        $sf = 0; // -> Contador, para seleccionar los nombres de los campos de la tabla activa.
        while($dv = mysql_fetch_array($rData)){
            $storeValues = null;
            //Recojo los datos para meterlos en el array mas grande
            foreach($fields as $field){
                //Devuelve los valores con claves numericas o strings
                if($method->recursiveValues){
                    $storeValues[$field] = $dv[$field];
                }else{
                    $storeValues[] = $dv[$field];
                }
                //Storea los campos
                if($sf == 0){
                    $storeFields[] = $field;
                }
            }
            $storeRender["values"][] = $storeValues; //-> Valores de cada fila inficvidual
            $sf++;
        }
        if(!$method->dropFieldsKey){
            //$storeRender["fields"] = $storeFields;
        }
        //devuelvo los valores encontrados
        return $storeRender;
    }
    /**
     * Function Search();
     * Realiza una consulta a la base de datos y extrae los resultados encontrados
     *
     * @access public
     * @param string tableAlias String que contiene el identificador de la tabla a operar
     * @param string array operatingFields null Los campos de los cuales quiero extraer datos
     * @param string array null conditioningFields Los campos que pongo como condiciones para limitar la busqueda
     * @param string array null operand El operando con el cual se relacionaran $conditioningFields y $needleVals [AND/OR]
     * @param string array null needleVals Los campos que pongo como valores para la condición de limitar la busqueda
     * @param string array null orderBy Orden en el que son devueltos los datos ordenados en un array
     * @param int array null selectRange Rango de selección
     *
     * @param string resource Alias del resource de la conexión
     */
    public function search($tableAlias,$operatingFields,$conditioningFields,$operand,$needleVals,$orderBy,$selectRange,$return,$resource){
        global $dbData;
        global $system;
        // 1 --- PRE CONDICIONES ---
        //echo($operatingFields);
        //El sistema detecta los factores que automaticamente hacen obsoleta la función:
        // Detecta si el numero de columnas es igual al nomero de valores asignadas a las mismas
        if(is_array($conditioningFields)){
            if(count($conditioningFields) != count($needleVals)){
                panic2("DataHandler",1100,"Number of columns missmatch the quantity of values assigned to them: <br/> Columns: ".count($conditioningFields)." <br/> Values: ".count($needlevals),true);
            }
        }
        
        if(is_array($operand)){
            if(count($operand) != (count($conditioningFields)-1)){
                panic2("DataHandler",1103,"Number of operands provided is invalid: <br> Expected:<b>".(count($conditioningFields)-1)."</b> <br>Provided:<b> ".count($operand)."</b>" ,true);
            }
        }
        if(!isset($dbData[$tableAlias])){
            panic2("DataHandler",1101,"Table alias provided is invalid",true);
        }

        if(!getDBRByAlias($resource)){
            panic2("DataHandler",1102,"Database alias provided is invalid",true);
        }
        $method->recursiveValues = true;

        // 2 --- SET DE CONDICIONES,PROPIEDADES,CHECKLISTS Y OPERACIONES PREVIO AL QUERY ---

        $i=0;
        if($operatingFields === "*" or !isset($operatingFields) or is_null($operatingFields)){
            $operatingFields = $this->retrieveColumns($tableAlias,$resource);
        }
        
         /*  Si $operatingFields es un array, entonces le digo al query que quiero buscar
         * multiples columnas. (Las especificadas)
         */
        
        if(is_array($operatingFields)){
           (array) $look4column = implode(", ",$operatingFields);

        }
        // Si $operatingFields es un string busco solo el campo pedido
      
        if(is_string($operatingFields)){
            $look4column = $operatingFields;
        //    echo("<b>".$look4column."</b>");
        }
        //Si $operatingFields es null, busco todos los campos posibles.
        if(is_null($operatingFields)){
            $look4column = "*";
        }
       
        //Si $operatingFields es un array busco los campos pedidos.
        if(is_array($conditioningFields)){
            $i = 0;
            /* Si no se pidio un operando especifico para la delimitación de busqueda,
             * se establece que el operando por defecto para operaciones entre dos
             * regiones de busqueda es "AND"
             */
            if(is_null($operand) or !isset($operand)){
                $operand = "AND";
            }

            foreach($conditioningFields as $sv){
                 // ARITHMETIC CHECK
                if(strpos($sv,",=")){
                    $sv = substr($sv,0,strpos($sv,',='));
                    $armOperand = "=";
                }
                if(strpos($sv,",>")){
                    $sv = substr($sv,0,strpos($sv,',>'));
                    $armOperand = ">";
                }
                if(strpos($sv,",<")){
                    $sv = substr($sv,0,strpos($sv,',<'));
                    $armOperand = "<";
                }
                if(strpos($sv,",LIKE")){
                    $sv = substr($sv,0,strpos($sv,',LIKE'));
                    $armOperand = " LIKE ";
                }
                if(!isset($armOperand)){
                    $armOperand = "=";
                }


                if(is_array($operand)){
                    // El operando varia segun lo ingresado en los parametros.
                    $setOP = $operand[$i-1];
                }else{
                    // El operando es siempre el mismo
                    $setOP = $operand;
                }
                if($i === 0){
                    $and = " WHERE ";
                }else{
                    $and = $setOP;
                }
                $content .= $and." ".$sv." ".$armOperand." '".$needleVals[$i]."' ";
                $i++;
            }
            unset($i);
        }
        //Si lookField es un string busco el campo pedido.
        if(is_string($conditioningFields)){
            // ARITHMETIC CHECK
            if(strpos($conditioningFields,",=")){
               $conditioningFields = substr($conditioningFields,0,strpos($conditioningFields,',='));
               $armOperand = "=";
            }
            if(strpos($conditioningFields,",>")){
               $conditioningFields = substr($conditioningFields,0,strpos($conditioningFields,',>'));
               $armOperand = ">";
            }
            if(strpos($conditioningFields,",<")){
               $conditioningFields = substr($conditioningFields,0,strpos($conditioningFields,',<'));
               $armOperand = "<";
            }
            if(strpos($conditioningFields,",LIKE")){
               $conditioningFields = substr($conditioningFields,0,strpos($conditioningFields,',LIKE'));
               $armOperand = " LIKE ";
            }
            if(!isset($armOperand)){
                $armOperand = "=";
            }
            $content = " WHERE ".$conditioningFields." ".$armOperand." '".$needleVals."' ";
        }

        // SETEO UN RANGO DE SELECCIÒN Y ORDEN DE DISPLAY PARA LOS RESULTADOS
        if(isset($orderBy)){
            if(is_array($orderBy)){
                /* Si el primer parametro de $orderBy es true ( en caso que este sea un Array)
                 * entonces el orden de devolución de datos es decreciente. De modo contrario
                 * se ordena ascendentemente.
                 */
                if(is_bool($orderBy[1])){
                    if($orderBy[1]){
                        $limitDir = "DESC";
                    }else{
                        $limitDir = "ASC";
                    }
                }
                /* Si el segundo parametro de $orderBy ( en caso que este sea un Array)
                 * es "DESC" entonces el orden de devolución de datos es decreciente.
                 * Si el parametro es "ASC" se ordena de modo ascendente.
                 */
                if(strtolower($orderBy[1]) === "asc" or strtolower($orderBy[1]) === "desc"){
                    $limitDir = $orderBy[1];
                }
                /* Si no se pidio un orden de devolución datos especifico, se
                 * ordena por el default.
                 */
                if(!isset($limitDir)){
                    $limitDir = $this->defaultSRD;
                }

                // Valor para analizar en caso de error
                 $aOB = $orderBy[0];
                 
                /* Si el primer parametro de $orderBy (en caso que este sea un Array)
                 * es otro array, significa que se está buscando ordenar los resultados
                 * bajo multiples criterios de campo.
                 * Ej: SELECT nombre FROM agenda ORDER BY id,edad,dni
                 * El siguiente codigo ordena en tal caso los campos en un string.
                 */
                if(is_array($orderBy[0])){
                   $orderColumn = implode(", ",$orderBy[0]);
                }else{
                    // Si se pide ordenar los resultados bajo un solo campo
                    $orderColumn = $orderBy[0];
                }
                
                    
                /* Si $orderBy no esta seteado, se ordenan los resultados por la
                 * columna "unica" de la tabla.
                 */
                if(!isset($orderBy[0]) or is_null($orderBy[0])){
                    $orderColumn = $dbData[$tableAlias]["uid"];
                }
                $orderBy = "ORDER BY ".$orderColumn." ".$limitDir;
            }else{
                // Valor para analizar en caso de error
                 $aOB = $orderBy;
                $orderBy = "ORDER BY ".$orderBy;
            }
        }

        //Seteo el rango de seleccion
        if(is_null($selectRange)){
            /* Si $selectRange es Null, no se limita la cantidad de filas que se busca
             * y se devuelven todas las encontradas que cumplen con las otras condiciones
             * del query.
             */
            $selectRange = "";
        }else{
            /* Los dos parametros del array $selectRange son criterios que limitan
             * la cantidad de filas devueltas.
             */
            

            if(is_array($selectRange)){
                $selectRL = $selectRange[0];
                $selectRR = $selectRange[1];
                $rangeLimit = " LIMIT ".$selectRL.",".$selectRR." ";
            }else{

                $rangeLimit = " LIMIT ".$selectRange." ";
            }
        }
      //  echo("<b>".$rangeLimit."</b>");

        //echo("SELECT ".$look4column." FROM ".$dbData[$tableAlias]["tablename"]." ".$content." ".$orderBy." ".$rangeLimit);
        /* Previo a ejecutar el query, le pido al sistema que no ejecute la alarma panic2()
         * en caso de que el query falle si el sistema esta en modo de debugeo. De este modo
         * si el query falla se puede hacer un analisis rapido de los posibles motivos.
         */
        if($system->debugMode){
            $this->queryCreatesPanic = false;
        }
       
        // Se ejecuta el query
        $sQRY = $this->query("SELECT ".$look4column." FROM ".$dbData[$tableAlias]["tablename"]." ".$content." ".$orderBy." ".$rangeLimit,$resource);
        
        
        // 3 --- SET DE ANALISIS Y OPERACIONES POSTERIORES AL QUERY ---

        //(En caso de error en debugMode)
        if($system->debugMode){
            if(mysql_errno(getDBRByAlias($resource))){
                // En caso de error busco
                $realColumns = $this->retrieveColumns($tableAlias,$resource);
                
                // Checkeo si los campos ingresados en $operatingFields son validos
                if(is_array($operatingFields)){
                    foreach($operatingFields as $tlf){
                        if(!in_array($tlf,$realColumns)){
                        
                         //print_r($tlf); echo("<br>"); print_r($realColumns);
                         panic2("DataHandler",1101,"Column name specified as the seccond parameter does not exist in this table: <b>".$tlf."</b>",true);
                        }
                    }
                }else{
                    
                    if(!in_array($operatingFields,$realColumns)){
                        panic2("DataHandler",1101,"Column name specified as the seccond parameter does not exist in this table: <b>".$operatingFields."</b>",true);
                    }
                }
                // Checkeo si los campos ingresados en $conditioningFields son validos

                if(is_array($conditioningFields)){
                    foreach($conditioningFields as $tsv){
                        if(!in_array($tsv,$realColumns)){
                         panic2("DataHandler",1101,"Column name specified as the third parameter does not exist in this table: <b>".$tsv."</b>",true);
                        }
                    }
                }else{
                    if(!is_null($conditioningFields)){
                        if(!in_array($conditioningFields,$realColumns)){
                            panic2("DataHandler",1101,"Column name specified as the third parameter does not exist in this table: <b>".$tsf."</b>",true);
                        }
                    }
                }
                // Checkeo si los campos ingresados en $orderBy son validos
                if(is_array($aOB)){
                    foreach($aOB as $obv){
                        if(!in_array($obv,$realColumns)){
                            panic2("DataHandler",1101,"Column name specified as the sixth parameter does not exist in this table: <b>".$obv."</b>",true);
                        }
                    }
                }else{
                    if(!in_array($aOB,$realColumns)){
                        panic2("DataHandler",1101,"Column name specified as the sixth parameter does not exist in this table: <b>".$aOB."</b>",true);
                    }
                }
            }
        }
        

        // Guardo la cantidad de resultados que devuelve la consulta:
        $resultQTY = mysql_num_rows($sQRY);
        // Escaneo de resultados
        while($dv = mysql_fetch_array($sQRY)){
            $storeValues = null;
            //Recojo los datos para meterlos en el array mas grande
            if(is_array($operatingFields)){
                foreach($operatingFields as $field){
                    //Devuelve los valores con claves numericas o strings
                    if(!$return[1]){
                        $storeValues[$field] = $dv[$field];
                    }else{
                        $storeValues[] = $dv[$field];
                    }
                    // Se almacenan los campos
                 if($sf == 0){
                    $storeFields[] = $field;
                 }
                }
            }
            //Busca los valores limitados de la busqueda
            if(is_string($operatingFields)){
                if(!$return[1]){
                    $storeValues[$operatingFields] = $dv[$operatingFields];
                }else{
                    $storeValues[] = $dv[$operatingFields];
                }
                if($sf == 0){
                    $storeFields[] = $operatingFields;
                 }
            }

            
            /* Si el resultado es de mas de una fila se genera un array multidimensional
             * de modo que cada registro de este array contenga a su vez otro array con los
             * datos ordenados por campos.
             */
            if($resultQTY > 1){
                if($extra[0]){
                    $storeRender["values"][] = $storeValues; //-> Valores de cada fila inficvidual
                }else{
                    $storeRender[] = $storeValues;
                }
            }else{
                if($extra[0]){
                    $storeRender["values"] = $storeValues;
                }else{
                    $storeRender = $storeValues;
                }
            }
            $sf++;
        }
        // RETURN
        if($return[0]){
           $storeRender["fields"] = $storeFields;
        }
        //Devuelvo los valores encontrados
        
        return $storeRender;
    }


  
    private $header = -1;
    public function db_fetch_search($searchResourceLink){
        /*
         * Function Search();
         * Realiza una consulta a la base de datos y extrae los resultados pulsando el contador interno
         *
         * Resumen de variables:
         * $search
         */
        // Si hay mas de un resultado en la consulta se devuelve uno a la vez y se mueve el cabezal
         if(is_array($searchResourceLink)){
            $this->header++; 
            if(isset($searchResourceLink[$this->header])){
                return $searchResourceLink[$this->header];
            }else{
                //Si no hay mas resultados se retorna false
                $this->header = -1;
                return false;
            }
          }
          // El mismo procedimiento anterior pero con un solo resultado.
         if(!isset($searchResourceLink[1])){
             if($this->header == 1){
                 return false;
             }
             $this->header++;
             return $searchResourceLink[0];
         }
    }



    // Una funciòn para eliminar una tabla.
    public function dropTable($alias,$resource){
        global $dbData;
        if(!isset($dbData[$alias])){
            panic2("DataHandler",1150,"Table alias provided is invalid",true);
        }
        if(!getDBRByAlias($resource)){
            //panic2("DataHandler",1151,"Database alias provided is invalid",true);
        }
        if($dbData[$alias]["protected"]){
            panic2("DataHandler",1152,"Attemped to delete a system protected table",true);
        }else{
         if($this->query("DROP TABLE ".$dbData[$alias]["tablename"],$resource)){
            return true;
         }
        }

    }
    //Crea un registro rápido en la base de datos.
    public function createQuickRegister($dbObject,$cData,$insData,$resource){
       //Chequeo que los parametros ingresados sean seguros
       
       // Recorro y armo todos los valores que se van a insertar en la base
       global $dbData;
       $i = 0;
       foreach($insData as $insD){
            if($i == 0){
                $newData .= "'".$insD."'";
            }else{
                $newData .= ",'".$insD."'";
            }
            $i++;
        }
        $i = 0;
        if($cData != null){
            //Si el usuario quiere ingresar campos especificos entonces:
            foreach($cData as $icolumn){
             if($i == 0){
                 $columns .= "`".$icolumn."`";
                }else{
                 $columns .= ",`".$icolumn."`";
             }
             $i++;
            }
        }else{
            // Si el usuario inserta los valores en el orden presentado en $dbObject["tablecolumns"] entonces:
          $tblColumns = $this->retrieveColumns($dbData[$dbObject]["tablename"],$resource);
          foreach($tblColumns as $icolumn){
            if($i == 0){
                 $columns .= "`".$icolumn."`";
                }else{
                 $columns .= ",`".$icolumn."`";
             }
             $i++;
            }
        }
        //Ejecuto el query(); antes de hacerlo, debe pasar por el sistema de seguridad
        //echo("INSERT INTO ".$dbData[$dbObject]["tablename"]." (".$columns.") VALUES (".$newData.")");
        $this->query("INSERT INTO ".$dbData[$dbObject]["tablename"]." (".$columns.") VALUES (".$newData.")",$resource);

    }
    //Modifica un registro rápido de la base de datos
    public function editQuickRegister($dbObject,$insData,$cData,$id,$resource){
        global $dbData;
        //$securityTest = new security();
        //$insData = $securityTest->getSafeParameters($insData,getDBRByAlias($resource));

        $i = 0;
        if($cData != null){
            //Si el usuario quiere editar campos especificos entonces:
            foreach($cData as $icolumn){
                if($i == 0){
                    // Cambio " " por ' '  Para que no se corte el string si se ingresa una palabra con apostrofe (DON'T)
                 $columns .= $icolumn." ='".$insData[$i]."'";
                 $i++;
                }else{
                 $columns .= ", ".$icolumn." ='".$insData[$i]."'";
                 $i++;
                }
            }
        }else{
            // Si el usuario edita los valores en el orden presentado en $dbObject["tablecolumns"] entonces:
          $i = 0;
          $tblColumns = $this->retrieveColumns($dbData[$dbObject]["tablename"],$resource);
          foreach($tblColumns as $icolumn){
            // El campo ID no debe ser modificado (Por lo menos no mediante este sistema)
            //Si el campo id es ingresado, no se procesa
            if($icolumn != $dbData[$dbObject]["uid"]){
                if($i == 0){
                    $columns .= $icolumn." ='".$insData[$i]."'";
                    $i++;
                }else{
                    $columns .= ", ".$icolumn." ='".$insData[$i]."'";
                    $i++;
                }
            }
         }
       }
       //echo("UPDATE ".$dbData[$dbObject]["tablename"]." SET ".$columns." WHERE ".$dbData[$dbObject]["uid"]." ='".$id."'");
       $this->query("UPDATE ".$dbData[$dbObject]["tablename"]." SET ".$columns." WHERE ".$dbData[$dbObject]["uid"]." ='".$id."'",$resource);
    }
    public function deleteQuickRegister($dbObject,$id,$resource){
        // You are about to delete Multiple files ---
        global $dbData;
        $this->query("DELETE FROM ".$dbData[$dbObject]["tablename"]." WHERE ".$dbData[$dbObject]["uid"]."='".$id."'",$resource);
    }
    //Devuelve un array con los nombres de las columnas de la tabla indicada
    public function retrieveColumns($alias,$resource){
        global $dbData;
        $clms = $this->query("SHOW COLUMNS FROM ".$dbData[$alias]["tablename"],$resource);
       while($column = mysql_fetch_array($clms)){
            $makeColumns[] = $column[0];
        }
        return $makeColumns;
    }
    //Busca en la base de datos la tabla que contiene la información sobre el resto de las tablas del sistema
    public function retrieveExtraTables($resource){
        global $dbData;
        global $system;
        $dbTables = $this->query("SELECT * FROM ".$system->databaseCfgTable,$resource);
        /* Agrego los valores encontrados en la base de datos a la variable que contiene la información
         * de las tablas.
         */
        while($dbt = mysql_fetch_array($dbTables)){
            $dbData[$dbt["tablealias"]]["tablename"] = $dbt["tablename"];
            $dbData[$dbt["tablealias"]]["uid"] = $dbt["tableuidfield"];
        }
    }
    /*
     * valueExists
     * Check if a value exists in a particular column
     */
    public function valueExists($dbObject,$searchNeedle,$column,$qty){
        global $dbData;
        if(!is_null($column)){
            $condition = "WHERE ".$column." = '".$searchNeedle."'";
        }
        if(is_int($qty)){
            $dL = "ORDER BY ".$dbData[$dbObject]["uid"]." DESC LIMIT ".$qty;
        }
        //echo("SELECT * FROM ".$dbData[$dbObject]["tablename"]." ".$condition);
        $dbve = $this->query("SELECT * FROM ".$dbData[$dbObject]["tablename"]." ".$condition,"primarydatabase");
        $results = mysql_num_rows($dbve);
        if(is_int($qty)){
            return $results;
        }
        if($results > 0){
            return true;
        }else{
            return false;
        }
    }

    function executeBackup($database,$ins_prop,$dir){
		$tables_names = mysql_query("SHOW TABLES FROM ".$database);
		while($extract_table = mysql_fetch_row($tables_names)){
			$s = "";
			$t = "";
			$tabs = mysql_query("SHOW COLUMNS FROM $extract_table[0]");
			switch($ins_prop){
				case 1:
					$s = "INSERT INTO $extract_table[0] (";
				break;
				case 2:
					$s = "INSERT IGNORE INTO $extract_table[0] (";
				break;
				case 3:
					$s = "REPLACE INTO $extract_table[0] (";
				break;
			}
			$m = ") VALUES (";
			$c = 0;
			$komma ="";
			while($xrow = mysql_fetch_row($tabs)){
				$c++;
				$t = $t.$komma."`$xrow[0]`";
				$komma = ",";
			}
			$query = mysql_query("SELECT * FROM ".$extract_table[0]);
			$c2 = 0;
			while($extract_row = mysql_fetch_row($query)){
				$komma2 = "";
				$final = "";
				for($i = 0;$i<$c;$i++){
					$final = $final.$komma2."'".addslashes($extract_row[$i])."'";
					$komma2 = ",";
				}
			$final_result = $final_result.$s." ".$t." ".$m." ".$final.");";
			}
		}
		$today = getdate();
                // Esto se puede simplificar usando la función file_put_contents
		$filename="$dir/backup-$today[mday]-$today[mon]-$today[year]-$today[minutes].sql";
		$tempvar = fopen($filename,"w");
		fwrite($tempvar, $final_result);
		fclose($tempvar);
	}
}
?>
