<?php

/**
 * Description of Stylesheet
 *
 * Esta clase agrupa todo lo referente a los estilos de un objeto .
 */
// Definiciones necesarias.
define('TYPE_ELEMENT', 0);
define('TYPE_ID', 1);
define('TYPE_CLASS', 2);

class Stylesheet {

    public $IDName;
    public $Type;
    public $AttribArray = array();
    private $Component = array('body', 'a', 'a:link', 'a:visited', 'a:active', 'a:hover',
            'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'ul', 'ol', 'li', 'p', 'div', 'table', 'tr', 'th', 'td',
            'form', 'input', 'textarea', 'label', 'fieldset', 'leyend', 'select', 'optgroup',
            'option', 'button', 'dl', 'dt', 'dd', '', '', '', '', '', '', '', '', '', '', '');

    public function __construct($name, $type = TYPE_ID) {

        switch ($type) {
            case TYPE_ELEMENT:
                $this->Type = '';
                break;
            case TYPE_ID:
                $this->Type = '#';
                break;
            case TYPE_CLASS:
                $this->Type = '.';
                break;
            default:
            // Si me pasan un parámetro desconocido, asumo que es para un ID.
                $this->Type = '#';
        }

        if (is_array($name)) {
            // Si el nombre que recibo es un array, significa que tengo un style
            // en una lista o un link que deseo escribir.
            $inputname = null;
            foreach ($name as $value) {
                if (is_int($value)) {
                    $inputname = $inputname . $this->Component[$value] . ' ';
                } else {
                    $inputname = $inputname . $value . ' ';
                }
            }
            // Una vez aplicado el procedimiento superior, el nombre final incluye
            // a cada uno de los items del arreglo que se paso como parámetro.
            $this->IDName = $inputname;
        } else {
            if (is_int($name)) {
                $this->IDName = $this->Component[$name];
            } else {
                $this->IDName = $name;
            }
        }
    }

    public function addAttribute($name, $value) {
        $this->AttribArray[$name] = $value;
    }

    public function HTMLize() {
        if (!empty($this->AttribArray)) {
            $output = $this->Type . $this->IDName . ' {' . PHP_EOL;
            foreach ($this->AttribArray as $name => $value) {
                $output = $output . $name . ':' . $value . ";" . PHP_EOL;
            }
            $output = $output . '}' . PHP_EOL;
        }
        return $output;
    }

}

?>
