<?php
attachModule(GUI, 'compinit');
attachModule(SEC,"SecurityFunctions");

class ExternWidget extends Widget {

    public $filaname = null;
    public $Widget = null;

    public function  __construct($ID, $filename) {
        $this->ID = $ID;
        $this->filaname = $filename;
    }
    public function attachGlobalVariables(&$globalvariables) {
        /*
         * attachGlobalVariables
         *
         * Esta función recibe como parámetro un array conteniendo las variables
         * globales definidas. El externwidget realiza en este momento el precargado
         * del widget elegido, para no tener que acceder mas veces a el.
        */
        global $system;
        // Guardo el arreglo dentro del objeto.
        $this->GLOBAL_VARIABLES = &$globalvariables;
        // Cargo el widget externo.
        $this->Widget = SafeUnSerialize($system->extWidgetsDir.$this->filaname.'.wdg');
        $this->Widget = unserialize($this->Widget);
        if ($this->Widget == null) {
            // Si el widget es nulo, genero un panic invisible.
            panic2('GUIHandler', 2005, 'The following path was specified: '.$this->filaname);
        }else {
            // Como el widget es no nulo, le asigno las variables globales.
            $this->Widget->attachGlobalVariables($this->GLOBAL_VARIABLES);
        }
    }
    public function retrieveStyles() {
        /*
         * Función retrieveStyles
         *
         * Esta función invoca extrae de todos los componentes internos los estilos
         * correspondientes, y los devuelve al componente de orden superior que lo llamo.
        */
        // Si el widget es no nulo, trabajo.
        if ($this->Widget != null) {
            // Creo el array con todos los estilos a ser devueltos
            $styleinfo = array();
            // Le pido al componente que devuelva sus estilos internos.
            // Extraigo los estilos devueltos.
            $aux = $this->Widget->retrieveStyles();
            // Verifico si me devolvieron un arreglo de estilos, o un estilo único.
            if(is_array($aux)) {
                // Si me devolvieron un arreglo de estilos, agrego los estilos individuales a $styleinfo
                foreach ($aux as $style) {
                    $styleinfo[] = $style;
                }
            }else {
                // Si lo devuelvo no es un arreglo, verifico que sea por lo menos una hoja de estilos.
                if(get_class($aux)=='Stylesheet') {
                    // Si aux es una Stylesheet, la agrego.
                    $styleinfo[] = $aux;
                }
            }
            // Devuelvo el array con todos los estilos.
            return $styleinfo;
        }
    }
    public function generateHTML() {
        /*
         *  Función generateHTML
         *
         * Esta función genera el código HTML correspondiente al widget, sin
         * considerar cuestiones de ejecución condicional. Esta función es llamada
         * por HTMLize para ejecutarse en caso de estar verificada la ejecución condicional.
        */
        if ($this->Widget != null) {
            // Genero la variable de salida output
            $output = new OutputManager();
            // Agrego a output la salida en HTML del componente.
            $output->addOutput($this->ExecuteComponent($this->Widget));
            // Devuelvo output a quien llamó la función.
            return $output->export_text();
        }
    }
}
?>
