<?php
/**
 * Widget para crear imágenes.
 */
attachModule(STR, 'WebFunctions');
attachModule(GUI, 'compinit');
global $system;
class ImageWidget extends Widget {
    public $AttribArray = array();

    public function __construct($link) {
        $this->setSource($link);
    }

    public function generateHTML() {
// Es importante que este activada la propiedad finalclose, ya que puede
// haber problemas sino.
        return insertTag('img', true, false, true, $this->AttribArray,true);
    }

    private function setSource($link) {
        global $system;
        // Verifico si el link contiene alguna clase de AECODE.
        $AECODE = new AECodeRunner($this->GLOBAL_VARIABLES);
        $link = $AECODE->parseAECODE($link);
        // Me fijo primero si la imagen existe en AEData/Images/
        if(file_exists('./AEData/Images/'.$link)) {
            global $system;
            //Si existe, fijo un path relativo
            $this->AttribArray['src'] = $system->relativePath.'/AEData/Images/'.$link;
        }else {
            //Si no existe, el path es absoluto.
            $this->AttribArray['src'] = $link;
        }
    }
    public function setAlternate($text) {
        $this->AttribArray['alt'] = $text;
    }
    public function setAttribute($name,$value) {
        $this->AttribArray[$name] = $value;
    }
}

?>
