<?php
/**
 * Widget estándar para fabricar menues.
 */
attachModule(STR, 'WebFunctions');
attachModule(GUI, 'compinit');

$index = 0;
define('Attribute',$index++);
define('ListAttribute',$index++);
define('LinkAttribute',$index++);
define('VisitedAttribute',$index++);
define('HoverAttribute',$index++);
define('ActiveAttribute',$index++);
unset($index);

class MenuWidget extends Widget {
    public $ItemArray = array();
    public function  __construct($name) {
        $this->ID = $name;
        // Los numeros de indice son para acceder a los estilos desde las funciones para fijar el orden de los estilos.
        $this->Styles = array();
        $this->Styles[Attribute] = new Stylesheet($name);
        $this->Styles[ListAttribute] = new Stylesheet(array($name,list_element));
        $this->addListAttribute('list-style-type', 'none');
        $this->Styles[LinkAttribute] = new Stylesheet(array($name,list_element, link_single));
        $this->Styles[VisitedAttribute] = new Stylesheet(array($name,list_element, link_visited));
        $this->Styles[HoverAttribute] = new Stylesheet(array($name,list_element, link_hover));
        $this->Styles[ActiveAttribute] = new Stylesheet(array($name,list_element, link_active));
    }
    public function generateHTML() {
        //Esta función agrupa el menú en un div.
        $output = new OutputManager();
        $output->addOutput( insertTag('div', true, true, false, array('id'=>$this->ID),true));

        // Agrego a output la salida en HTML de cada componente.
        foreach($this->Components as $Component) {
            $MenuItem = new LinkWidget($Component[1], $Component[0]);
            $MenuItem = $this->ExecuteComponent($MenuItem);
            if ($MenuItem != null) {
                $output->addOutput( insertTag('li', true, false, false,null,true));
                $output->addOutput($MenuItem);
                $output->addOutput( insertTag('li', false, true, false,null,true));
            }
        }
        $output->addOutput( insertTag('div', false, true, false,null,true));
        return $output->export_text();
    }
    public function addComponent($Component,$link) {
        /*
         * Función addComponent
         *
         * Esta función agrega componentes al menu, con su respectivo link.
        */
        $this->Components[] = array($Component,$link);
    }
    public function addAttribute($name,$value) {
        /*
         * Esta función agrega atributos al div que agrupa al menu.
        */
        $this->Style[Attribute]->addAttribute($name,$value);
    }
    public function addListAttribute($name,$value) {
        /*
         * Esta función agrega atributos a la lista de los menues.
        */
        $this->Style[ListAttribute]->addAttribute($name,$value);
    }
    public function addLinkAttribute($name,$value) {
        /*
         * Esta función agrega atributos a los links
        */
        $this->Style[LinkAttribute]->addAttribute($name,$value);
    }
    public function addVisitedAttribute($name,$value) {
        /*
         * Esta función agrega atributos a los links visitados
        */
        $this->Style[VisitedAttribute]->addAttribute($name,$value);
    }
    public function addHoverAttribute($name,$value) {
        /*
         * Esta función agrega atributos al link con el cursor encima
        */
        $this->Style[HoverAttribute]->addAttribute($name,$value);
    }
    public function addActiveAttribute($name,$value) {
        /*
         * Esta función agrega atributos al link activo
        */
        $this->Style[ActiveAttribute]->addAttribute($name,$value);
    }





}

?>
