<?php
global $system;
attachModule(GUI,'compinit');
attachModule(STR,'WebFunctions');
attachModule(SEC,'SecurityFunctions');

/**
 * Description of Renderer
 *
 * Clase que gestiona el rendering de la página.
 */

function RenderPage($maskfile) {
    /* Descripción de lo que hace la funcion*/
    // Declaro variables globales
    global $system;

    // Primero, se recupera la página serializada.
    $page = SafeUnSerialize($maskfile);
    // Si la máscara es false, el archivo no existe.
    if (!$page) {
        // Si esto se ejecuta, el archivo de la máscara no existe.
        //print_r($page);

        // AGREGAR ACA FUNCION QUE PROCESE EL ERROR.
    }else {
        // En este punto, deserializo la página.
        $page = unserialize($page);
        // Realizo el preprocesamiento de la página
        $page->preprocess();
        // Instancio un OutputManager
        $output = new OutputManager();
        // Genero el DOCTYPE
        $output->addOutput('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">');
        // Formato en: XHTML 1.0 Transitional
        // Agrego el tag de HTML
        $output->addOutput(insertTag('html', true, false, false, null, true));
        // Agrego el tag de HEAD
        $output->addOutput(insertTag('head', true, false, false, null, true));
        // Extraigo las hojas de estilos de la página
        $stylearray = $page->retrieveStyles();
        // Agrego el tag de STYLE
        $output->addOutput(insertTag('style', true, false, false, null, true));
        // Genero todos los estilos
        foreach($stylearray as $Style) {
            $output->addOutput($Style->HTMLize());
        }
        // Cierro el tag de STYLE
        $output->addOutput(insertTag('style', false, false, false, null, true));
        // Agrego el tag META
        $output->addOutput(insertTag('meta', true, false, false, array('http-equiv'=>'Content-Type','content'=>'text/html','charset'=>$system->encoding), true));
        // Genero el título
        $title = insertTag('title', true, false, false, null, true).$page->title.insertTag('title', false, false, false, null, true);
        $output->addOutput($title);
        // Cierro el tag de HEAD
        $output->addOutput(insertTag('head', false, false, false, null, true));
        // Agrego el tag de BODY
        $output->addOutput(insertTag('body', true, false, false, null, true));
        // Genero internamente todos los objetos
        $output->addOutput($page->HTMLize());
        // Cierro el tag BODY
        $output->addOutput(insertTag('body', false, false, false, null, true));
        // Cierro el tag HTML
        $output->addOutput(insertTag('html', false, false, false, null, true));
        // Una vez compilado todo el texto, lo publico.
        $output->export();
    }
}





?>
