<?php
attachModule(STR, 'SearchFunctions');
attachModule(STR, 'WebFunctions');
global $DatabaseManager;
/*
 * Language Manager
 *
 * Serie de funciones para administrar Idiomas, proveyendo una interfaz de uso.
 *
*/

function getTextbyID($IDtext) {
    /*
     * getTextbyId
     *
     * Esta función devuelve el valor del campo correspondiente a la ID indicada
     * mediante la sintaxis "ID: %d", detectando automáticamente el idioma especificado
     * previamente por el AEKernel.
     * En caso de querer indicar un texto fijo, se debe anteponer el prefijo "Text: ".
    */

    global $DatabaseManager;
    global $currentLANG;
    /*
     * Verifico si estoy indicando una ID o un texto fijo.
    */
    if(StartsWith($IDtext, "ID: ")) {
        // Extraigo el numero de ID que me pasaron.
        $ID = trim(substr($IDtext, 3));
        if (!is_numeric($ID)) {
            // Si ID no es un entero, genero un reporte de error no critico y devuelvo void.
            panic2('International', 3000, 'The following IDtext was provided: '.$IDtext);
            return null;
        }else {
            // Si el ID es un numero, lo extraigo de la base de datos.
            $var = $DatabaseManager->query("SELECT caption FROM engine_languages WHERE textid='".$ID."' AND lang='".$currentLANG."'");
            $var = mysql_fetch_assoc($var);
            if ($var == null) {
                panic2('International', 3001, 'The following IDtext was provided: '.$IDtext);
                return '';
            }else {
                $var = $var['caption'];
                $var = utf8tohtml($var);
                return $var;
            }
        }
    }elseif(StartsWith($IDtext, "Text: ")) {
        // Si me indicaron que devuelva texto, lo devuelvo.
        return utf8tohtml(substr($IDtext, 5));
    }else {
        panic2('International', 3002, 'The following IDtext was provided: '.$IDtext);
        return '';
    }
}
function addLanguage($shortname,$fullname) {
    /*
     * addLanguage
     *
     * Esta función genera todos los campos correspondientes a un nuevo idioma.
     * Los parámetros que se reciben son:
     * shortname: abreviatura del nombre
     * fullname: nombre del idioma
     * Ejemplo: en - English
     *
    */
    global $DatabaseManager;
    // Paso 1: Agregar el idioma a la lista de los idiomas soportados.
    $DatabaseManager->query("INSERT INTO engine_lang_names (short, lang) VALUES ('".$shortname."','".$fullname."')");
    // Paso 2: Crear los ID correspondientes para el idioma nuevo.

    $languages = $DatabaseManager->search("engineLangs", "short",null,null,null,null,null,null,"primarydatabase");
    // Extraccion de la lista de idiomas provisoria hasta la nueva version de retrieveDbData.
    foreach ($languages as $value) {
        $aux[]=$value['short'];
    }
    $languages = $aux;

    // Obtengo la cantidad de entradas revisando el lenguage por defecto.
    $var = $DatabaseManager->query("SELECT textid FROM engine_languages WHERE lang='".$languages[0]."' ORDER BY textid ASC");
    $row = mysql_fetch_assoc($var);
    while($row) {
        $textidlist[] = $row['textid'];
        $row = mysql_fetch_assoc($var);
    }
    // Creo todas las entradas para el nuevo idioma, inicializadas vacias.
    foreach($textidlist as $textid) {
        $DatabaseManager->query("INSERT INTO engine_languages (textid, lang, caption) VALUES ('".$textid."','".$shortname."','')");
    }
}
function removeLanguage($name) {
    /*
     * removeLanguage
     *
     * Esta función elimina todos los campos correspondientes al idioma indicado.
     * El parámetro que se pasa tiene que ser el nombre abreviado del idioma.
     * Ejemplo: English - en
     *
    */
    global $DatabaseManager;
    $DatabaseManager->query("DELETE FROM engine_lang_names WHERE short='".$name."'");
    $DatabaseManager->query("DELETE FROM engine_languages WHERE lang='".$name."'");
}
function editEntry($ID,$lang,$newvalue) {
    /*
     * editEntry
     *
     * Esta función edita una entrada correspondiente a una ID y a un idioma en particular.
     * En ID se indica el número de campo a editar;
     * En lang se indica el idioma al cual corresponde la modificación; Ejemplo: English - en;
     * En newvalue se indica el nuevo valor que debe poseer esa entrada en particular.
     *
    */
    global $DatabaseManager;
    $DatabaseManager->query("UPDATE engine_languages SET caption='".$newvalue."' WHERE textid='".$ID."' AND lang='".$lang."'");

}
function addEntry($defaultvalues) {
    /*
     * addEntry
     *
     * Esta función genera una nueva entrada de datos para un idioma en particular,
     * asignandole el valor por defecto indicado en defaultvalue.
     * Los parámetros se pasan por arreglos asociativos: Array('lang' => 'value',..)
     * El valor de retorno es la ID de los nuevos textos.
    */
    // El valor de retorno debe ser el ID de la nueva entrada
    global $DatabaseManager;
    // Averiguo primero la lista de lenguajes disponibles.
    $languages = $DatabaseManager->search("engineLangs", "short",null,null,null,null,null,null,"primarydatabase");
    // Extraccion de la lista de idiomas provisoria hasta la nueva version de retrieveDbData.
    foreach ($languages as $value) {
        $aux[]=$value['short'];
    }
    $languages = $aux;
    // Fin codigo provisorio.
    // Obtengo la cantidad de entradas revisando el lenguage por defecto.
    $var = $DatabaseManager->query("SELECT textid FROM engine_languages WHERE lang='".$languages[0]."' ORDER BY textid DESC");
    $lastidused = mysql_fetch_assoc($var);
    $lastidused = $lastidused['textid'];
    $ID = $lastidused + 1;
    foreach($languages as $language) {
        if (array_key_exists($language, $defaultvalues))
            $entry = $defaultvalues[$language];
        else
            $entry = '';
        $DatabaseManager->query("INSERT INTO engine_languages (textid, lang, caption) VALUES ('".$ID."','".$language."','".$entry."')");
    }
    return $ID;


}
function removeEntry($ID) {
    /*
     * removeEntry
     *
     * Esta función remueve una entrada en particular, junto a sus equivalentes
     * en los demás idiomas. Esta acción es irreversible.
     *
    */
    global $DatabaseManager;
    $DatabaseManager->query("DELETE FROM engine_languages WHERE textid='".$ID."'");
}
?>
