<?php
/**
 * Description of AECparser
 *
 * La funcion AECparse es capaz de procesar string, buscar los fragmentos de AECODE,
 * interpretar la función buscada, sus parámetros, y ejecutarla.
 */

// SINTAXIS: [#AECODE|nombreFuncion|param1|param2|...|AECODE#]

function AECparse($code,&$dataarray = array()) {
    // Si hay un AECODE, ejecuto el código dentro del while.
    // La presencia del offset es para acortar el tiempo de búsqueda de AECODEs
    // subsiguientes, generando un desplazamiento de la lectura.
    $offset = 0;
    while(@strpos($code, '[#AECODE',$offset)!==false) {
        // Guardo el inicio y fin en variables para hacer el asunto más rápido.
        $inicio = strpos($code, '[#AECODE',$offset);
        // Asimismo, $fin genera el nuevo offset.
        $fin = strpos($code, 'AECODE#]',$offset) + 8;
        // Extraigo el AECODE del String.
        $AECODE = substr($code,$inicio,$fin - $inicio);
        // Genero el array con los fragmentos de codigo
        $paramarray = array();
        // Extraigo el primer y segundo fragmento del codigo.
        strtok($AECODE, '|');
        $tok = strtok('|');
        // Cargo al array el resto de los fragmentos.
        while ($tok !== false && $tok != 'AECODE#]') {
            $paramarray[] = $tok;
            $tok = strtok('|');
        }
        // Genero el nuevo offset
        $offset = $fin;
         // Interpreto el AECODE y devuelvo el resultado por AERETURN
        switch ($paramarray[0]) {
            case 'WRITE':
            /*
                 * La función write devuelve el texto indicado como primer parámetro.
            */
                $AERETURN = $paramarray[1];
                break;
            case 'GETVAR':
            /*
             * GETVAR devuelve la variable de nombre indicado en como primer parámetro.
            */
                $AERETURN = $dataarray[$paramarray[1]];
                break;
            case 'RETRLANG':
            /*
             * Esta función extrae de la base de datos de lenguajes el ID asociado
             */
            // Esta función todavía no funciona.
                break;
            case 'RETRDB':
                /*
                 * Esta función
                 */

                break;
            default:
                break;
        }


        // Reemplazo el AECODE por su código html correspondiente.
        $code = substr_replace($code, $AERETURN, $inicio,$fin - $inicio);
    }
    // Si ya no quedan AECODEs, devuelvo el texto procesado.
    return $code;

    // El llamado a las funciones es genérico. A cada clase/funcion se le pasa
    // durante su construcción un array con todos los parámetros. Y al final de
    // su construcción, la función debe devolver el código html correspondiente
    // para reemplazar el AECODE del texto que se introdujo, de manera automática.
}

?>
