<?php
/* Errorcode list
 *
 * En esta página están alojadas todas las constantes de todos los error codes.
 * El formato a usarse es "CODE[]", siendo las [] el número de error.
 * Para hacer el asunto entendible, se recomienda usar el formato:
 * Dir1 -> Dir2 ... -> Archivo/Clase -> Funcion_que_da_error -> Error
 *
 * En el manager hay una función para acceder a los errorcodes.
 *
 * Guía de enumeración de errores:
 * 0-100: Errores del Kernel-Config
 * Espacio libre para otros errores.
 * 1000-1999: Errores del DataHandler
 * 2000-2999: Errores del GUIHandler
 * 3000-3999: Errores del International
 * 4000-4999: Errores del Manager
 * 5000-5999: Errores del Security
 * 6000-6999: Errores del SessionHandler
 * 7000-7999: Errores del Standard
*/

$errorcodes = array();
// 0-100: Errores del Kernel-Config

$errorcodes['CODE0'] = 'Kernel -> ConfigFileNotFound';
$errorcodes['CODE1'] = 'Kernel -> ErrorCodesFileNotFound';
$errorcodes['CODE2'] = 'Kernel -> PageMapFileNotFound';
$errorcodes['CODE3'] = 'Kernel -> ManagerPageMapFileNotFound';
$errorcodes['CODE4'] = 'Kernel -> TableStorageFileNotFound';
$errorcodes['CODE5'] = 'Kernel -> InstallerNotFound';

$errorcodes['CODE16'] = 'Kernel -> StartKernel -> PageIDNotExistent';
$errorcodes['CODE17'] = 'Kernel -> StartKernel -> LanguageRequestedNotAvailable';
$errorcodes['CODE18'] = 'Kernel -> attachModule -> ModuleLoadFailure';
$errorcodes['CODE19'] = 'Kernel -> Initiate_Kernel -> PageIDNotFound';
$errorcodes['CODE20'] = 'Config -> Documents -> LanguageFileNotFound';
$errorcodes['CODE21'] = 'Config -> PageMapNotFound';

// Espacio libre para otros errores.

// 1000-1999: Errores del DataHandler
$errorcodes['CODE1000'] = 'MySQLmanager -> connect -> ConnectionToDBFailed';
$errorcodes['CODE1001'] = 'MySQLmanager -> connect -> InvalidDatabaseAlias';
$errorcodes['CODE1002'] = 'MySQLmanager -> connect -> DatabaseCurrentlyNotSupported';
$errorcodes['CODE1003'] = 'MySQLmanager -> connect -> DatabaseEngineCurrentlyNotSupported';

$errorcodes['CODE1050'] = 'MySQLmanager -> dropTable -> InvalidTableAlias';
$errorcodes['CODE1051'] = 'MySQLmanager -> dropTable -> InvalidDatabaseAlias';
$errorcodes['CODE1052'] = 'MySQLmanager -> dropTable -> invalidProtectedTableDrop';

$errorcodes['CODE1100'] = 'MySQLmanager -> search -> InputParametersCountMissmatch';
$errorcodes['CODE1101'] = 'MySQLmanager -> search -> InvalidTableAlias';
$errorcodes['CODE1102'] = 'MySQLmanager -> search -> InvalidDatabaseAlias';
$errorcodes['CODE1102'] = 'MySQLmanager -> search -> InputParametersCountMissmatch';

$errorcodes['CODE1150'] = 'database -> _construct -> InvalidDatabaseAlias';

$errorcodes['CODE1500'] = 'sqlInterface -> newInterface -> InvalidDatabaseAlias';
$errorcodes['CODE1501'] = 'sqlInterface -> newInterface -> InvalidDatabaseAlias';


// 2000-2999: Errores del GUIHandler
$errorcodes['CODE2000'] = 'GUIHandler -> Webpage -> HTMLize -> SkinNotArray';
$errorcodes['CODE2001'] = 'GUIHandler -> Widget -> RetrieveStyles -> SkinNotArray';
$errorcodes['CODE2002'] = 'GUIHandler -> Widget -> ExecuteComponent -> ConditionalExecutionTypeNotKnown';
$errorcodes['CODE2003'] = 'GUIHandler -> Widget -> ExecuteComponent -> TrueConditionNotBoolean';
$errorcodes['CODE2004'] = 'GUIHandler -> LinkWidget -> generateHTML -> InternalWidgetNotSet';
$errorcodes['CODE2005'] = 'GUIHandler -> ExternWidget -> attachGlobalVariables -> WidgetNotFound';

// 3000-3999: Errores del International
$errorcodes['CODE3000'] = 'International -> LanguageManager ->getTextByID -> IDnotNumeric';
$errorcodes['CODE3001'] = 'International -> LanguageManager ->getTextByID -> IDnonExistant';
$errorcodes['CODE3002'] = 'International -> LanguageManager ->getTextByID -> TextIDnonParseable';

// 4000-4999: Errores del Manager

// 5000-5999: Errores del Security

// 6000-6999: Errores del SessionHandler

// 7000-7999: Errores del Standard

// 8000-8999: Errores del AECODE
$errorcodes['CODE8000'] = 'OperandNotRecognized';
$errorcodes['CODE8001'] = 'DataTypesNotCompatible: StringToNumeric';
$errorcodes['CODE8002'] = 'NotAVariable';
$errorcodes['CODE8001'] = 'DataTypesNotCompatible: ';
$errorcodes['CODE8001'] = 'DataTypesNotCompatible: ';
$errorcodes['CODE8001'] = 'DataTypesNotCompatible: ';
$errorcodes['CODE8001'] = 'DataTypesNotCompatible: ';



?>
